/* utmp_lib.c
 * (c)17.10.1998 by Marek Zelem
 */

#include "utmp_lib.h"
#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>

#ifndef	GOOD_UTMP

static int utmp_fd=-1;
static char utmp_name[1024];

static int m_open_utmp( void )
{	if( utmp_fd>=0 )	return( utmp_fd );
	utmp_fd=open(utmp_name,O_RDONLY);
	return( utmp_fd );
}
static void m_close_utmp( void )
{	if( utmp_fd>=0 )	close(utmp_fd);
	utmp_fd=-1;
}

void m_utmpname(const char *file)
{	strncpy(utmp_name,file,1023);
	utmp_name[1023]=0;
}

void m_setutent(void)
{ int fd;
	if( (fd=m_open_utmp())>=0 )
	{	lseek(fd,0,SEEK_SET);
	}
}

void m_endutent(void)
{	m_close_utmp();
}

#define kopiruj(to,from)	\
	{ int l;\
		l=sizeof(to);\
		if( sizeof(from)<l )	l=sizeof(from);\
		memcpy(to,from,l);\
		if( sizeof(to)>l )	((char*)to)[l]=0;\
	}

static struct m_utmp ut;
struct m_utmp *m_getutent(void)
{ int fd;
  struct real_utmp buf;
	if( (fd=m_open_utmp())<0 )	return(NULL);
	if( read(fd,&buf,sizeof(struct real_utmp))!=sizeof(struct real_utmp) )
		return( NULL );
	ut.ut_type=buf.ut_type;
	ut.ut_pid=buf.ut_pid;
	kopiruj(ut.ut_line,buf.ut_line);
	kopiruj(ut.ut_id,buf.ut_id);
#ifdef MUTMP_DIFTIME
	ut.ut_time=buf.ut_tv.tv_sec;
#else  MUTMP_DIFTIME
	ut.ut_time=buf.ut_time;
#endif MUTMP_DIFTIME
	kopiruj(ut.ut_user,buf.ut_user);
	kopiruj(ut.ut_host,buf.ut_host);
	ut.ut_addr=buf.ut_addr;
	return( &ut );
}

#endif	GOOD_UTMP

